/**
 * @file main.c
 * @brief Demo for configuration of display OLED I2C
 * @date 22/06/2023
 * @author Wu Shin-Ting
 */

#include "derivative.h" /* include peripheral declarations */
#include "SIM.h"
#include "I2C_OLED.h"

int main(void)
{
	/*
	 * Pre-scaler = 1
	 * https://mcuoneclipse.com/2012/12/05/kl25z-and-i2c-missing-repeated-start-condition/
	 */
	SIM_setaOUTDIV4 (0b000);

	//Set I2C connection to SSD1306 
	I2C_initConSSD1306();

	//Initialize OLED (SSD1306)
	I2C_initOLED();

	uint8_t i, j;

	for (;;) {
		for (i=0; i<32; i++)
		{
			for (j=0; j<64; j++) {
				I2C_OLED_setPixel (32+j, 16+i);
			}
		}

		I2C_OLED_redisplay();

		pause_5us(50000);

		I2C_OLED_clrScrBuf();

		I2C_OLED_redisplay();

		pause_5us(50000);
	}

	return 0;
}
